package sams.chp10;

import db2xml.xml.*;
import db2xml.util.*;
import db2xml.jdbc.*;
import javax.servlet.http.*;
import javax.servlet.*;
import java.io.*;
import java.util.*;

public class DB2XMLServlet extends HttpServlet
{
    private JDBCXMLProperties map;
    public void setProperty(String key, String value)
    {
        map.setProperty(key, value);
    }
    public void init(ServletConfig config) throws ServletException
    {
        super.init(config);
        try
        {
            map = new JDBCXMLProperties();
        }
        catch (DB2XMLException e)
        {
            throw new ServletException(e.getMessage());
        }
    }

    public void doGet(HttpServletRequest req, HttpServletResponse res)
      throws IOException, ServletException
    {
        setProperty("out", "stream");
        setProperty("el.binfields", "ignore");
        map.setBooleanProperty("el.protectStrings", true);
        setProperty("genDTD", "intern");

        res.setContentType("text/xml");
        PrintWriter out = res.getWriter();

        res.setStatus(HttpServletResponse.SC_OK);
        try
        {
          JDBCXML jx = new JDBCXML(map);
          jx.generateXML();
          XMLOutput outServ = new XMLOutput(map,out,jx.getXMLDocument());
          outServ.writeToOutput();
          out.flush();
          jx.closeDatabase();
        }
        catch(Exception e)
        {
          out.println("DB2XMLServlet exception: " + e);
          e.printStackTrace(out);
          out.flush();
        }
    }
}
