<?xml version="1.0"?>
<xsl:stylesheet
    xmlns:xsl="http://www.w3.org/XSL/Transform/1.0"
    xmlns="http://www.w3.org/TR/REC-html40" result="ns">
  

<xsl:template match="/"> 
    <html><body>
    <xsl:apply-templates/> 
    </body></html>
</xsl:template>

<xsl:template match="Header">
    <head><title><xsl:value-of select="."/></title></head>
    <center><h1><xsl:value-of select="."/></h1></center>
</xsl:template>
<!--This rule causes the State tag to be ignored-->
<xsl:template match="State"></xsl:template>

<xsl:template match="County">
    <h2>Within the county of:<xsl:value-of select="@Name"/></h2>
    <xsl:value-of select="@Description"/>
    <xsl:apply-templates match="Town"/>
</xsl:template>

<xsl:template match="Town">
    <h3><xsl:value-of select="TownName"/> </h3>
    <table>
    <th>Listing Broker</th>
    <th>Property Type</th>
    <th>Price</th>
    <th>Address</th>
    <xsl:apply-templates match="Listing"/>
    </table>
</xsl:template>

<xsl:template match="Listing">
    <tr>
    <td><xsl:value-of select="ListingBroker"/></td>
    <td><xsl:value-of select="Type"/></td>
    <td><xsl:text>$</xsl:text><xsl:value-of select="ListingPrice"/></td>
    <td><xsl:value-of select="Addr"/></td>
    </tr>
</xsl:template>

<!-- If there isn't a template rule ignore it -->
<xsl:template></xsl:template>
</xsl:stylesheet>