<?xml version="1.0"?>
<!-- 
    A simple style sheet for placing a header and footer on any document.
	Al Saganich for MacMillan Publishing
	This template was tested using James Clark's XT for Win32
-->

<!-- Use the transform version 1.0 namespace -->
<xsl:stylesheet
    xmlns:xsl="http://www.w3.org/XSL/Transform/1.0"
	indent-result="no" default-space="strip">

<!-- 
	Match the root 
	Bracket everything in header/trailers
-->

<xsl:template match="/">
	<xsl:apply-templates select="catheader"/>
	<xsl:apply-templates />
	<xsl:apply-templates select="cattrailer"/>
</xsl:template>

<!--
	This rule matches the catheader.
	The action we perform is to insert straight text using xsl:text
	And follow it by the value of the catheader.
-->
<xsl:template match="catheader">
	<xsl:text>Header:</xsl:text>
	<xsl:value-of select="."/>
</xsl:template>

<!-- The cattrailer production rule matches the catheader rule except, 
    obviously, it applies to cattrailers
-->
<xsl:template match="cattrailer">
	<xsl:text>Trailer:</xsl:text>
	<xsl:value-of select="."/>
</xsl:template>


</xsl:stylesheet>