<?xml version="1.0"?>
<xsl:stylesheet
    xmlns:xsl="http://www.w3.org/XSL/Transform/1.0"
    xmlns:fo="http://www.w3.org/1999/XSL/Format"
    indent-result="no" default-space="strip" > <!-- result-ns="fo"> -->
    
        
    <xsl:template match="/">
            <fo:root xmlns:fo="http://www.w3.org/1999/XSL/Format">
            <fo:layout-master-set>
            <fo:simple-page-master page-master-name="cheap"
                  height="8.5in" 
                  width="11in"
                  margin-top="0.5in" 
                  margin-bottom="0.5in" 
                  margin-left="1in" 
                  margin-right="1in">
              <fo:region-before extent="1in"/>
              <fo:region-body margin-top="1.25in"/>
              <fo:region-after extent=".75in"/>
                </fo:simple-page-master>
            </fo:layout-master-set>
        <fo:page-sequence>
            <fo:sequence-specification>
                <fo:sequence-specifier-single page-master-name="cheap"/>
            </fo:sequence-specification>
            <fo:static-content flow-name="xsl-before">
                <fo:block font-size="18pt" 
                font-family="sans-serif" 
                line-height="24pt"
                background-color="black"
                color="white"
                text-align="centered"
                padding-top="3pt">
                    <xsl:apply-templates select="/REListing/Header"/>
                </fo:block>         
            </fo:static-content>
            <fo:static-content flow-name="xsl-after">
                <fo:block font-size="18pt" 
                font-family="sans-serif" 
                line-height="24pt"
                text-align="centered"
                padding-top="3pt">
                    page:<fo:page-number/>
                </fo:block>         
                </fo:static-content >
            <fo:flow>
                 <xsl:apply-templates/>
            </fo:flow>
        </fo:page-sequence>
    </fo:root>
    </xsl:template>
    
    <xsl:template match="Header">
        <xsl:value-of select="."/>
    </xsl:template>

    <xsl:template match="Listing[ListingPrice &lt; 150000]">
        <fo:block font-size="12pt" font-family="sans-serif">
        <xsl:value-of select="."/>
        </fo:block>
        <fo:block font-size="10pt" font-family="sans-serif">
           taxrate:<xsl:value-of select="../TaxRate"/>
           applied rate:$<xsl:value-of select="round((ListingPrice div 1000) * ../TaxRate)"/> a year
        </fo:block>
    </xsl:template>
</xsl:stylesheet>