package sams.chp6;

import java.io.*;
import java.util.*;
import org.w3c.dom.*;


public class DOMArray extends ArrayList
{
    public DOMArray (Node parent,String tag)
    {
        NodeList elements = parent.getChildNodes();
        if ( elements.getLength()== 0)
        {
            return;
        }

        for (int i = 0; i < elements.getLength(); i++)
        {
            Element anElement = (Element) elements.item(i);
            if ( anElement.getNodeName().equals(tag))
            	this.add(anElement);

        } // end for
    }
	public Node getAsNode(int index)
	{
		return (Node) get(index);
	}
    public DOMArray (Document parent,String tag)
    {
        NodeList elements = parent.getElementsByTagName( tag);
        if ( elements.getLength()== 0)
        {
            return;
        }

        for (int i = 0; i < elements.getLength(); i++)
        {
            Element anElement = (Element) elements.item(i);
            this.add(anElement);

        } // end for
    }
    public static void main (String argv [])
    {
        if (argv.length != 2)
        {

            System.err.println("Usage: java sams.chp8.DOMArray filename tag");
            System.exit(1);
        }

        Document document;
        try
        {
            document = XMLUtil.openDocument(argv[0]);
            System.out.println("Document successfully created!");

            DOMArray test = new DOMArray(document, argv[1]);
            Iterator it = test.iterator();
            while (it.hasNext())
            {
                Element e = (Element) it.next();
                XMLUtil.displayNodeInfo("",e);
            }

        }
        catch (Exception e)
        {
            System.out.println("Unexpected exception reading document!" +e);
            System.exit (0);
        }
        System.exit (0);

    }

}