package sams.chp6;

import java.io.*;
import java.util.*;
import org.w3c.dom.*;

public class TestDOMList
{

    public static void main (String argv [])
    {
        if (argv.length < 2)
        {

            System.err.println("Usage: java sams.chp8.DOMArray filename tag [comparison method]" );
            System.exit(1);
        }

        Document document;
        try
        {
            document = XMLUtil.openDocument(argv[0]);
            System.out.println("Document successfully created!");

            DOMList test = new DOMList(document, argv[1]);
            if (argv.length == 3)
            {
                String which = argv[2];
                System.out.println("Attempting to sort by "+ which);
                Comparator c = null;
                if (which.equals("int"))
                    c = new DOMCollectionUtilities.IntegerElementComparator();
                else if (which.equals("float"))
                    c = new DOMCollectionUtilities.FloatElementComparator();
                else if (which.equals("string"))
                    c = new DOMCollectionUtilities.StringElementComparator();
                if ( null != c)
                    Collections.sort(test,c);
            }
            Iterator it = test.iterator();
            while (it.hasNext())
            {
                Element e = (Element) it.next();
                XMLUtil.displayNodeInfo("",e);
            }

        }
        catch (Exception e)
        {
            System.out.println("Unexpected exception reading document!" +e);
            System.exit (0);
        }
        System.exit (0);

    }

}