/* ProcessAphorismForm.java */
package sams.chp9;

import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import java.io.*;

public class ProcessAphorismForm extends HttpServlet
{
    RandomAccessFile raf;
    public static String [] skeleton = 
                  { "<?xml version=\"1.0\" ?>",
                    "<APHORISMS>",
                    " </APHORISMS>", // extra space on purpose
                  };
                  
    private byte [] stringArrayToBuf(String [] strs)
    {
        byte [] buf = null;        
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        OutputStreamWriter osw = new OutputStreamWriter(baos);
        PrintWriter pw = new PrintWriter(osw);
        for (int i=0; i < strs.length; i++)
            pw.println(strs[i]); 
        pw.flush();
        buf = baos.toByteArray();    
        return buf;
    }

    private byte [] formToElement(Hashtable formvals)
    {
        byte [] buf = null;        
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        OutputStreamWriter osw = new OutputStreamWriter(baos);
        PrintWriter pw = new PrintWriter(osw);
        String [] s = null;
        pw.println("<APHORISM_RECORD>");             
        pw.println("<TITLE>"); 
        s = (String []) formvals.get("Title");
        for (int i = 0; i < s.length; i++)
            pw.println(s[i]);
        pw.println("</TITLE>"); 
        pw.println("<NAME>"); 
        s = (String []) formvals.get("Name");
        for (int i = 0; i < s.length; i++)
            pw.println(s[i]);
        pw.println("</NAME>"); 
        pw.println("<SOURCE>"); 
        s = (String []) formvals.get("Source");
        for (int i = 0; i < s.length; i++)
            pw.println(s[i]);
        pw.println("</SOURCE>"); 
        pw.println("<CATEGORY>"); 
        s = (String []) formvals.get("Category");
        for (int i = 0; i < s.length; i++)
            pw.println(s[i]);
        pw.println("</CATEGORY>"); 
        pw.println("<APHORISM>"); 
        s = (String []) formvals.get("Aphorism");
        for (int i = 0; i < s.length; i++)
            pw.println(s[i]);
        pw.println("</APHORISM>"); 
        pw.println("<DESCRIPTION>"); 
        s = (String []) formvals.get("Description");
        for (int i = 0; i < s.length; i++)
            pw.println(s[i]);        
        pw.println("</DESCRIPTION>"); 
        pw.println("</APHORISM_RECORD>"); 
        // NOTE: as the last record, include end tag
        pw.println(" </APHORISMS>");
        pw.flush();
        buf = baos.toByteArray();            
        return buf;
    }
                                      
    public void init(ServletConfig config)
                                   throws ServletException
    {
        try
        {
            raf = new RandomAccessFile("Aphorisms.xml", "rw");    
            if (raf.length() == 0)
            {
                // first time
                byte [] buf = stringArrayToBuf(skeleton);
                raf.write(buf);
            }
        } catch (IOException ioe)
          {
            throw new ServletException("Reason: " + ioe);
          }
    }
    
    public void doPost(HttpServletRequest req,
                       HttpServletResponse res)
                                throws ServletException,
                                       java.io.IOException
    {
        ServletInputStream sis = req.getInputStream();
        int iLength = req.getContentLength();
        String encoding = req.getCharacterEncoding();
        
        /* Note keys are form element names, 
           vals are arrays of Strings. */
        Hashtable formvals = HttpUtils.parsePostData(iLength, sis);        
        
        // format XML Element from Hashtable
        byte [] elem = formToElement(formvals);
        
        // append to XML document before End tag.
        int length = (int) raf.length();
        raf.seek(length - "  </APHORISMS>\n".length());
        raf.write(elem);
        
        // output confirmation 
        res.setContentType("text/html");
        PrintWriter pw = res.getWriter();
        pw.println("<HTML>");
        pw.println("<HEAD>");
        pw.println("<TITLE> Processed Form </TITLE>");
        pw.println("</HEAD>");
        pw.println("<BODY>");
        pw.println("<H1> Your Aphorism has been submitted! </H1>");
        String [] s = null;
        pw.println("Title: "); 
        s = (String []) formvals.get("Title");
        for (int i = 0; i < s.length; i++)
            pw.println(s[i] + "<BR>");
        pw.println("Name: "); 
        s = (String []) formvals.get("Name");
        for (int i = 0; i < s.length; i++)
            pw.println(s[i] + "<BR>");
        pw.println("Source: ");
        s = (String []) formvals.get("Source");
        for (int i = 0; i < s.length; i++)
            pw.println(s[i] + "<BR>");
        pw.println("Category: ");
        s = (String []) formvals.get("Category");
        for (int i = 0; i < s.length; i++)
            pw.println(s[i] + "<BR>");
        pw.println("Aphorism: ");
        s = (String []) formvals.get("Aphorism");
        for (int i = 0; i < s.length; i++)
            pw.println(s[i] + "<BR>");
        pw.println("Description: ");
        s = (String []) formvals.get("Description");
        for (int i = 0; i < s.length; i++)
            pw.println(s[i] + "<BR>");
        pw.println("</BODY>");
        pw.println("</HTML>");        
    }    
    
    public void destroy()
    {
        try
        {
            raf.close();
        } catch (IOException ioe) { }
    }
}
